︠1345e1e0-242a-4305-bf17-3f49212f3240is︠
%html
<h2 style="color:blue">
    Bard - Sage - Row Reduction Demo
</h2>
︡dcb59385-98f7-452b-9d92-b9623d5b5b5a︡{"html":"<h2 style=\"color:blue\">\n    Bard - Sage - Row Reduction Demo\n</h2>\n"}︡
︠8c0e3f17-7c49-4a83-b5b7-4b4ea1e44f6dis︠
%html

<h3>
    Using the Sage Interface
</h3>

<ul>
    <li>Each activity starts after a gray horizontal line.</li>
    <li>Write the commands, then put the cursor in the code, and then click on Run.</li>
    <li>The output will appear after the commands, and a new gray line will appear, allowing for a new activity.</li>
    <li>If there is an error in the code, error messages will appear in red.</li>
    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>
    </ul>

︡d8883c4d-d143-4e0a-bd4a-9ba586cc28e9︡{"html":"\n<h3>\n    Using the Sage Interface\n</h3>\n\n<ul>\n    <li>Each activity starts after a gray horizontal line.</li>\n    <li>Write the commands, then put the cursor in the code, and then click on Run.</li>\n    <li>The output will appear after the commands, and a new gray line will appear, allowing for a new activity.</li>\n    <li>If there is an error in the code, error messages will appear in red.</li>\n    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>\n    </ul>\n\n"}︡
︠5e69c7b6-79ce-4afc-8724-9a5ad5d383a2is︠
%html

<h3 style="color:red">
    IMPORTANT
</h3>

<ul>
    <li>Every time you start this worksheet, the first thing yyou need to do is to load the definitions by putting the cursor in the code in the following box and then clicking on Run.</li>
</ul>
︡3769ffdf-5a74-4667-a371-b2e782802328︡{"html":"\n<h3 style=\"color:red\">\n    IMPORTANT\n</h3>\n\n<ul>\n    <li>Every time you start this worksheet, the first thing yyou need to do is to load the definitions by putting the cursor in the code in the following box and then clicking on Run.</li>\n</ul>\n"}︡
︠62728ac0-8e26-44fe-a5c0-b1aee9271361s︠
def mult_row_r_by_s(M,r,s):
    N = M.rescale_row(r-1,s)
    return N
def switch_rows_i_and_k(M,i,k):
    N = M.swap_rows(i-1,k-1)
    return N
def add_s_times_row_i_to_row_k(M,s,i,k):
    N = M.add_multiple_of_row(k-1,i-1,s)
    return N
︡bdfce89a-e2bc-47a9-886e-2253c125abbb︡
︠01cefb36-ad0b-4469-b926-cbd8c1d147e6︠
%html

<h4>
    Defining a matrix
</h4>

<ul>
    <li>When a matrix is defined, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the definition of the matrix.</li>
    <li>The <tt>QQ</tt> in the following example tell Sage to think of the matrix as having rational number entries.  If you replace <tt>QQ</tt> with <tt>RR</tt>, as in the next example, the matrix will be displayed with decimal entries.</li>
</ul>
︡70ff0f99-3b7a-4a7f-9f9d-a852a1b434e9︡{"html":"\n<h4>\n    Defining a matrix\n</h4>\n\n<ul>\n    <li>When a matrix is defined, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the definition of the matrix.</li>\n    <li>The <tt>QQ</tt> in the following example tell Sage to think of the matrix as having rational number entries.  If you replace <tt>QQ</tt> with <tt>RR</tt>, and in the next example, the matrix will be displayed with decimal entries.</li>\n</ul>\n"}︡
︠712bc9c2-076b-4784-97d5-6d66fca8ddb9s︠
M = Matrix(QQ,[[1,2,3],[3,2,1],[4,1,-1]])
M
︡2f2b6549-185e-4726-b479-22256d7dd0eb︡{"stdout":"[ 1  2  3]\n[ 3  2  1]\n[ 4  1 -1]\n"}︡
︠8bad9ca5-5ff8-4314-a133-ea458aa32269s︠
P = Matrix(RR,[[1,2,3],[3,2,1],[4,1,-1]])
P
︡7403b226-5388-49f0-9779-7dae7d9fffc7︡{"stdout":"[ 1.00000000000000  2.00000000000000  3.00000000000000]\n[ 3.00000000000000  2.00000000000000  1.00000000000000]\n[ 4.00000000000000  1.00000000000000 -1.00000000000000]\n"}︡
︠16a93eed-c73f-4002-9aec-57fbcba0de7fi︠
%html

<h4>
    Multiplying a row of a matrix by a number
</h4>

<ul>
    <li>In the command <tt>mult_row_r_by_s(M,r,s)</tt>, replace the <tt>M</tt>, <tt>r</tt> and <tt>s</tt> in the parentheses with the name of the matrix, the row number and the scalar, respectively.</li>
    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>
</ul>
︡511224e6-dfa2-47ce-9c90-8ff03548d69c︡{"html":"\n<h4>\n    Multiplying a row of a matrix by a number\n</h4>\n\n<ul>\n    <li>In the command <tt>mult_row_r_by_s(M,r,s)</tt>, replace the <tt>M</tt>, <tt>r</tt> and <tt>s</tt> in the parentheses with the name of the matrix, the row number and the scalar, respectively.</li>\n    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>\n</ul>\n"}︡
︠cd21fb58-1981-40c8-b840-a6e2dc8c0e87s︠
mult_row_r_by_s(M,2,5)
M
︡6cd1f1e2-da18-4526-8bfc-c266f6d6290e︡{"stdout":"[ 1  2  3]\n[15 10  5]\n[ 4  1 -1]\n"}︡
︠1d76ce22-e7e8-40c8-93f5-6de86650a804i︠
%html

<h4>
    Switching two rows of a matrix
</h4>

<ul>
    <li>In the command <tt>switch_rows_i_and_k(M,i,k)</tt>, replace the <tt>M</tt>, <tt>i</tt> and <tt>k</tt> in the parentheses with the name of the matrix and the row numbers of the two rows that are being switched.</li>
    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>
</ul>
︡8b10466b-7837-4f16-b5b0-4e894c9cf5ce︡{"html":"\n<h4>\n    Switching two rows of a matrix\n</h4>\n\n<ul>\n    <li>In the command <tt>switch_rows_i_and_k(M,i,k)</tt>, replace the <tt>M</tt>, <tt>i</tt> and <tt>k</tt> in the parentheses with the name of the matrix and the row numbers of the two rows that are being switched.</li>\n    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>\n</ul>\n"}︡
︠34528e79-6692-4819-a895-b0b9fa01f835s︠
switch_rows_i_and_k(M,2,3)
M
︡627bf612-b523-435b-b315-6a855156187a︡{"stdout":"[ 1  2  3]\n[ 4  1 -1]\n[15 10  5]\n"}︡
︠02fbc9e1-64b2-4e28-b6d0-f4d1224acb15︠
%html

<h4>
    Adding a multiple of one row of a matrix to another row of the matrix
</h4>

<ul>
    <li>In the command <tt>add_s_times_row_i_to_row_k(M,s,i,k)</tt>, replace the <tt>M</tt>, <tt>s</tt>, <tt>i</tt> and <tt>k</tt> in the parentheses with the name of the matrix, the scalar, the row number of the row being multiplied and the row number of the row to which the multiple is being added, respectively.</li>
    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>
</ul>
︡dba14513-dec4-49dc-9be8-528406f87e80︡{"html":"\n<h4>\n    Adding a multiple of one row of a matrix to another row of the matrix\n</h4>\n\n<ul>\n    <li>In the command <tt>add_s_times_row_i_to_row_k(M,s,i,k)</tt>, replace the <tt>M</tt>, <tt>s</tt>, <tt>i</tt> and <tt>k</tt> in the parentheses with the name of the matrix, the scalar, the row number of the row being multiplied and the row number of the row to which the multiple is being added, respectively.</li>\n    <li>Here too, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the command.</li>\n</ul>\n"}︡
︠8c994df0-0243-47f8-9b2b-9045c0a8c942s︠
add_s_times_row_i_to_row_k(M,-4,1,2)
M
︡8097788f-615d-46f0-b68e-c5befa89f82e︡{"stdout":"[  1   2   3]\n[  0  -7 -13]\n[ 15  10   5]\n"}︡
︠22e5c8c4-bf6d-4d9f-ba69-73fd94874b86is︠
%html

<h4>
    Example of row reduction
</h4>

<ul>
    <li>In this example we do each command separately, starting with the definition of the matrix, and we have the matrix displayed each time, so that we can see the result of each row operation.</li>
</ul>
︡6474a64f-7cb2-46b9-92ee-5db64a725445︡{"html":"\n<h4>\n    Example of row reduction\n</h4>\n\n<ul>\n    <li>In this example we do each command separately, starting with the definition of the matrix, and we have the matrix displayed each time, so that we can see the result of each row operation.</li>\n</ul>\n"}︡
︠c7ffacc7-930e-40a2-a95c-7c4d5c88ffaes︠
N = Matrix(QQ,[[3,2,-4,5],[2,2,0,1],[4,1,-1,6],[-5,0,1,-3]])
N
︡b382ace9-2894-4418-85ca-c03e413cf111︡{"stdout":"[ 3  2 -4  5]\n[ 2  2  0  1]\n[ 4  1 -1  6]\n[-5  0  1 -3]\n"}︡
︠4baf6d28-2a37-4adb-b00d-9a564d558e29s︠
mult_row_r_by_s(N,1,1/3)
N
︡d683418a-aeb0-4ebb-a6c2-9837c8e5b680︡{"stdout":"[   1  2/3 -4/3  5/3]\n[   2    2    0    1]\n[   4    1   -1    6]\n[  -5    0    1   -3]\n"}︡
︠7cc75f6d-e8ff-47f4-83de-62fd7a6273b8s︠
add_s_times_row_i_to_row_k(N,-2,1,2)
N
︡69557671-c395-43a3-881d-9d5d08a5d4b5︡{"stdout":"[   1  2/3 -4/3  5/3]\n[   0  2/3  8/3 -7/3]\n[   4    1   -1    6]\n[  -5    0    1   -3]\n"}︡
︠27a932d3-fc2e-4f4c-ac19-dd74ac2ecc0bs︠
add_s_times_row_i_to_row_k(N,-4,1,3)
N
︡0ebb8441-216a-4e7b-ad0a-de23b245c83b︡{"stdout":"[   1  2/3 -4/3  5/3]\n[   0  2/3  8/3 -7/3]\n[   0 -5/3 13/3 -2/3]\n[  -5    0    1   -3]\n"}︡
︠5737cf2c-c651-41a7-ada7-f10960c2d212s︠
add_s_times_row_i_to_row_k(N,5,1,4)
N
︡7600799e-d180-4a28-9084-21bc224fad6d︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0   2/3   8/3  -7/3]\n[    0  -5/3  13/3  -2/3]\n[    0  10/3 -17/3  16/3]\n"}︡
︠7840b430-066b-455d-808c-f0cf1c53b520s︠
mult_row_r_by_s(N,2,3/2)
N
︡c4c2f520-d80d-41ce-ba7a-ce8143a347e0︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0     1     4  -7/2]\n[    0  -5/3  13/3  -2/3]\n[    0  10/3 -17/3  16/3]\n"}︡
︠91474bc4-cf81-4723-a96b-31e23b44809bs︠
add_s_times_row_i_to_row_k(N,5/3,2,3)
N
︡08d04a70-e597-4cfb-b99a-328ce01840d1︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0     1     4  -7/2]\n[    0     0    11 -13/2]\n[    0  10/3 -17/3  16/3]\n"}︡
︠f874eaa3-2a38-4dc1-ab7f-7cd16c8d0ef5s︠
add_s_times_row_i_to_row_k(N,-10/3,2,4)
N
︡ac57a503-1bad-4a34-ac6d-eba4391e7e11︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0     1     4  -7/2]\n[    0     0    11 -13/2]\n[    0     0   -19    17]\n"}︡
︠8b13e00f-16a9-476f-9e65-ff8c2901a408s︠
mult_row_r_by_s(N,3,1/11)
N
︡fc012d29-272f-42b7-90fa-7dfd5793751e︡{"stdout":"[     1    2/3   -4/3    5/3]\n[     0      1      4   -7/2]\n[     0      0      1 -13/22]\n[     0      0    -19     17]\n"}︡
︠c536dcc1-3c5e-42d3-a7d5-2741d22d90bcs︠
add_s_times_row_i_to_row_k(N,19,3,4)
N
︡9a97b028-39ab-43dd-a43e-d1a7ad17db6f︡{"stdout":"[     1    2/3   -4/3    5/3]\n[     0      1      4   -7/2]\n[     0      0      1 -13/22]\n[     0      0      0 127/22]\n"}︡
︠a66856b7-12b9-4157-9fca-ec6e7282948fis︠
%html

<h4>
    Combining row operations
</h4>

<ul>
    <li>Any number of row operations can be grouped together, with each command on a separate line, before displaying the end result in the final line.  The definition of the matrix can also be included in this groups of commands, though it can also be done separately.</li>
    <li>Combining row operations is good if you want to get to the final result as effieciently as possible, though even then it only works to "clear out one column" in a single group of row operations.  If you want to show the result of each row operation, you need to do only one row operation at a time.</li>
</ul>
︡626648cc-e67b-4909-8657-02d3a664fad9︡{"html":"\n<h4>\n    Combining row operations\n</h4>\n\n<ul>\n    <li>Any number of row operations can be grouped together, with each command on a separate line, before displaying the end result in the final line.  The definition of the matrix can also be included in this groups of commands, though it can also be done separately.</li>\n    <li>Combining row operations is good if you want to get to the final result as effieciently as possible, though even then it only works to \"clear out one column\" in a single group of row operations.  If you want to show the result of each row operation, you need to do only one row operation at a time.</li>\n</ul>\n"}︡
︠b8571ee2-b76b-45ac-9a4d-31c95a27b947s︠
A = Matrix(QQ,[[3,2,-4,5],[2,2,0,1],[4,1,-1,6],[-5,0,1,-3]])
mult_row_r_by_s(A,1,1/3)
add_s_times_row_i_to_row_k(A,-2,1,2)
add_s_times_row_i_to_row_k(A,-4,1,3)
add_s_times_row_i_to_row_k(A,5,1,4)
A
︡5cc081c5-7efb-4fd7-95cb-6ecb8dcce562︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0   2/3   8/3  -7/3]\n[    0  -5/3  13/3  -2/3]\n[    0  10/3 -17/3  16/3]\n"}︡
︠83f3e6d9-39c3-4275-a4ae-096637a76893s︠
mult_row_r_by_s(A,2,3/2)
add_s_times_row_i_to_row_k(A,5/3,2,3)
add_s_times_row_i_to_row_k(A,-10/3,2,4)
A
︡1f57887c-41c4-437e-bb82-27154ea9d547︡{"stdout":"[    1   2/3  -4/3   5/3]\n[    0     1     4  -7/2]\n[    0     0    11 -13/2]\n[    0     0   -19    17]\n"}︡
︠25e33569-a735-40fa-a330-2e88d6b92e1cs︠
mult_row_r_by_s(A,3,1/11)
add_s_times_row_i_to_row_k(A,19,3,4)
A
︡6e6397e3-b9d7-4cc5-aaf9-00dabf28afb1︡{"stdout":"[     1    2/3   -4/3    5/3]\n[     0      1      4   -7/2]\n[     0      0      1 -13/22]\n[     0      0      0 127/22]\n"}︡
︠eb001c66-81af-4962-8b59-c4c7a03647f7︠









